/* AUTOGENERATED FILE. DO NOT EDIT. */
#include <string.h>
#include <stdlib.h>
#include <setjmp.h>
#include "cmock.h"
#include "mock_xtruntime.h"

static const char* CMockString_cmock_arg1 = "cmock_arg1";
static const char* CMockString_excnum = "excnum";
static const char* CMockString_handler = "handler";
static const char* CMockString_intnum = "intnum";
static const char* CMockString_param = "param";
static const char* CMockString_pprev = "pprev";
static const char* CMockString_xtos_interrupt_enable = "xtos_interrupt_enable";
static const char* CMockString_xtos_set_exception_handler = "xtos_set_exception_handler";
static const char* CMockString_xtos_set_interrupt_handler = "xtos_set_interrupt_handler";

typedef struct _CMOCK_xtos_set_exception_handler_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  int32_t ReturnVal;
  uint32_t Expected_excnum;
  xtos_handler Expected_handler;
  xtos_handler* Expected_pprev;
  int Expected_pprev_Depth;
  char ReturnThruPtr_pprev_Used;
  xtos_handler* ReturnThruPtr_pprev_Val;
  size_t ReturnThruPtr_pprev_Size;
  char IgnoreArg_excnum;
  char IgnoreArg_handler;
  char IgnoreArg_pprev;

} CMOCK_xtos_set_exception_handler_CALL_INSTANCE;

typedef struct _CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  int32_t ReturnVal;
  uint32_t Expected_intnum;
  xtos_handler Expected_handler;
  void* Expected_param;
  xtos_handler* Expected_pprev;
  int Expected_param_Depth;
  int Expected_pprev_Depth;
  char ReturnThruPtr_param_Used;
  void* ReturnThruPtr_param_Val;
  size_t ReturnThruPtr_param_Size;
  char ReturnThruPtr_pprev_Used;
  xtos_handler* ReturnThruPtr_pprev_Val;
  size_t ReturnThruPtr_pprev_Size;
  char IgnoreArg_intnum;
  char IgnoreArg_handler;
  char IgnoreArg_param;
  char IgnoreArg_pprev;

} CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE;

typedef struct _CMOCK_xtos_interrupt_enable_CALL_INSTANCE
{
  UNITY_LINE_TYPE LineNumber;
  char ExpectAnyArgsBool;
  uint32_t Expected_cmock_arg1;
  char IgnoreArg_cmock_arg1;

} CMOCK_xtos_interrupt_enable_CALL_INSTANCE;

static struct mock_xtruntimeInstance
{
  char xtos_set_exception_handler_IgnoreBool;
  int32_t xtos_set_exception_handler_FinalReturn;
  char xtos_set_exception_handler_CallbackBool;
  CMOCK_xtos_set_exception_handler_CALLBACK xtos_set_exception_handler_CallbackFunctionPointer;
  int xtos_set_exception_handler_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE xtos_set_exception_handler_CallInstance;
  char xtos_set_interrupt_handler_IgnoreBool;
  int32_t xtos_set_interrupt_handler_FinalReturn;
  char xtos_set_interrupt_handler_CallbackBool;
  CMOCK_xtos_set_interrupt_handler_CALLBACK xtos_set_interrupt_handler_CallbackFunctionPointer;
  int xtos_set_interrupt_handler_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE xtos_set_interrupt_handler_CallInstance;
  char xtos_interrupt_enable_IgnoreBool;
  char xtos_interrupt_enable_CallbackBool;
  CMOCK_xtos_interrupt_enable_CALLBACK xtos_interrupt_enable_CallbackFunctionPointer;
  int xtos_interrupt_enable_CallbackCalls;
  CMOCK_MEM_INDEX_TYPE xtos_interrupt_enable_CallInstance;
} Mock;

extern jmp_buf AbortFrame;

void mock_xtruntime_Verify(void)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_MEM_INDEX_TYPE call_instance;
  call_instance = Mock.xtos_set_exception_handler_CallInstance;
  if (Mock.xtos_set_exception_handler_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_xtos_set_exception_handler);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.xtos_set_exception_handler_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.xtos_set_interrupt_handler_CallInstance;
  if (Mock.xtos_set_interrupt_handler_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_xtos_set_interrupt_handler);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.xtos_set_interrupt_handler_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
  call_instance = Mock.xtos_interrupt_enable_CallInstance;
  if (Mock.xtos_interrupt_enable_IgnoreBool)
    call_instance = CMOCK_GUTS_NONE;
  if (CMOCK_GUTS_NONE != call_instance)
  {
    UNITY_SET_DETAIL(CMockString_xtos_interrupt_enable);
    UNITY_TEST_FAIL(cmock_line, CMockStringCalledLess);
  }
  if (Mock.xtos_interrupt_enable_CallbackFunctionPointer != NULL)
  {
    call_instance = CMOCK_GUTS_NONE;
    (void)call_instance;
  }
}

void mock_xtruntime_Init(void)
{
  mock_xtruntime_Destroy();
}

void mock_xtruntime_Destroy(void)
{
  CMock_Guts_MemFreeAll();
  memset(&Mock, 0, sizeof(Mock));
}

int32_t xtos_set_exception_handler(uint32_t excnum, xtos_handler handler, xtos_handler* pprev)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_xtos_set_exception_handler);
  cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.xtos_set_exception_handler_CallInstance);
  Mock.xtos_set_exception_handler_CallInstance = CMock_Guts_MemNext(Mock.xtos_set_exception_handler_CallInstance);
  if (Mock.xtos_set_exception_handler_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    if (cmock_call_instance == NULL)
      return Mock.xtos_set_exception_handler_FinalReturn;
    Mock.xtos_set_exception_handler_FinalReturn = cmock_call_instance->ReturnVal;
    return cmock_call_instance->ReturnVal;
  }
  if (!Mock.xtos_set_exception_handler_CallbackBool &&
      Mock.xtos_set_exception_handler_CallbackFunctionPointer != NULL)
  {
    int32_t cmock_cb_ret = Mock.xtos_set_exception_handler_CallbackFunctionPointer(excnum, handler, pprev, Mock.xtos_set_exception_handler_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return cmock_cb_ret;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (!cmock_call_instance->ExpectAnyArgsBool)
  {
  if (!cmock_call_instance->IgnoreArg_excnum)
  {
    UNITY_SET_DETAILS(CMockString_xtos_set_exception_handler,CMockString_excnum);
    UNITY_TEST_ASSERT_EQUAL_HEX32(cmock_call_instance->Expected_excnum, excnum, cmock_line, CMockStringMismatch);
  }
  if (!cmock_call_instance->IgnoreArg_handler)
  {
    UNITY_SET_DETAILS(CMockString_xtos_set_exception_handler,CMockString_handler);
    UNITY_TEST_ASSERT_EQUAL_MEMORY((void*)(&cmock_call_instance->Expected_handler), (void*)(&handler), sizeof(xtos_handler), cmock_line, CMockStringMismatch);
  }
  if (!cmock_call_instance->IgnoreArg_pprev)
  {
    UNITY_SET_DETAILS(CMockString_xtos_set_exception_handler,CMockString_pprev);
    if (cmock_call_instance->Expected_pprev == NULL)
      { UNITY_TEST_ASSERT_NULL(pprev, cmock_line, CMockStringExpNULL); }
    else
      { UNITY_TEST_ASSERT_EQUAL_MEMORY_ARRAY((void*)(cmock_call_instance->Expected_pprev), (void*)(pprev), sizeof(xtos_handler), cmock_call_instance->Expected_pprev_Depth, cmock_line, CMockStringMismatch); }
  }
  }
  if (Mock.xtos_set_exception_handler_CallbackFunctionPointer != NULL)
  {
    cmock_call_instance->ReturnVal = Mock.xtos_set_exception_handler_CallbackFunctionPointer(excnum, handler, pprev, Mock.xtos_set_exception_handler_CallbackCalls++);
  }
  if (cmock_call_instance->ReturnThruPtr_pprev_Used)
  {
    UNITY_TEST_ASSERT_NOT_NULL(pprev, cmock_line, CMockStringPtrIsNULL);
    memcpy((void*)pprev, (void*)cmock_call_instance->ReturnThruPtr_pprev_Val,
      cmock_call_instance->ReturnThruPtr_pprev_Size);
  }
  UNITY_CLR_DETAILS();
  return cmock_call_instance->ReturnVal;
}

void CMockExpectParameters_xtos_set_exception_handler(CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance, uint32_t excnum, xtos_handler handler, xtos_handler* pprev, int pprev_Depth);
void CMockExpectParameters_xtos_set_exception_handler(CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance, uint32_t excnum, xtos_handler handler, xtos_handler* pprev, int pprev_Depth)
{
  cmock_call_instance->Expected_excnum = excnum;
  cmock_call_instance->IgnoreArg_excnum = 0;
  memcpy((void*)(&cmock_call_instance->Expected_handler), (void*)(&handler),
         sizeof(xtos_handler[sizeof(handler) == sizeof(xtos_handler) ? 1 : -1])); /* add xtos_handler to :treat_as_array if this causes an error */
  cmock_call_instance->IgnoreArg_handler = 0;
  cmock_call_instance->Expected_pprev = pprev;
  cmock_call_instance->Expected_pprev_Depth = pprev_Depth;
  cmock_call_instance->IgnoreArg_pprev = 0;
  cmock_call_instance->ReturnThruPtr_pprev_Used = 0;
}

void xtos_set_exception_handler_CMockIgnoreAndReturn(UNITY_LINE_TYPE cmock_line, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_exception_handler_CALL_INSTANCE));
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_exception_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_exception_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_exception_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
  Mock.xtos_set_exception_handler_IgnoreBool = (char)1;
}

void xtos_set_exception_handler_CMockStopIgnore(void)
{
  if(Mock.xtos_set_exception_handler_IgnoreBool)
    Mock.xtos_set_exception_handler_CallInstance = CMock_Guts_MemNext(Mock.xtos_set_exception_handler_CallInstance);
  Mock.xtos_set_exception_handler_IgnoreBool = (char)0;
}

void xtos_set_exception_handler_CMockExpectAnyArgsAndReturn(UNITY_LINE_TYPE cmock_line, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_exception_handler_CALL_INSTANCE));
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_exception_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_exception_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_exception_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
  cmock_call_instance->ExpectAnyArgsBool = (char)1;
}

void xtos_set_exception_handler_CMockExpectAndReturn(UNITY_LINE_TYPE cmock_line, uint32_t excnum, xtos_handler handler, xtos_handler* pprev, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_exception_handler_CALL_INSTANCE));
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_exception_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_exception_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_exception_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_xtos_set_exception_handler(cmock_call_instance, excnum, handler, pprev, 1);
  cmock_call_instance->ReturnVal = cmock_to_return;
}

void xtos_set_exception_handler_AddCallback(CMOCK_xtos_set_exception_handler_CALLBACK Callback)
{
  Mock.xtos_set_exception_handler_IgnoreBool = (char)0;
  Mock.xtos_set_exception_handler_CallbackBool = (char)1;
  Mock.xtos_set_exception_handler_CallbackFunctionPointer = Callback;
}

void xtos_set_exception_handler_Stub(CMOCK_xtos_set_exception_handler_CALLBACK Callback)
{
  Mock.xtos_set_exception_handler_IgnoreBool = (char)0;
  Mock.xtos_set_exception_handler_CallbackBool = (char)0;
  Mock.xtos_set_exception_handler_CallbackFunctionPointer = Callback;
}

void xtos_set_exception_handler_CMockExpectWithArrayAndReturn(UNITY_LINE_TYPE cmock_line, uint32_t excnum, xtos_handler handler, xtos_handler* pprev, int pprev_Depth, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_exception_handler_CALL_INSTANCE));
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_exception_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_exception_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_exception_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_xtos_set_exception_handler(cmock_call_instance, excnum, handler, pprev, pprev_Depth);
  cmock_call_instance->ReturnVal = cmock_to_return;
}

void xtos_set_exception_handler_CMockReturnMemThruPtr_pprev(UNITY_LINE_TYPE cmock_line, xtos_handler* pprev, size_t cmock_size)
{
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_exception_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringPtrPreExp);
  cmock_call_instance->ReturnThruPtr_pprev_Used = 1;
  cmock_call_instance->ReturnThruPtr_pprev_Val = pprev;
  cmock_call_instance->ReturnThruPtr_pprev_Size = cmock_size;
}

void xtos_set_exception_handler_CMockIgnoreArg_excnum(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_exception_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_excnum = 1;
}

void xtos_set_exception_handler_CMockIgnoreArg_handler(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_exception_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_handler = 1;
}

void xtos_set_exception_handler_CMockIgnoreArg_pprev(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_set_exception_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_exception_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_exception_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_pprev = 1;
}

int32_t xtos_set_interrupt_handler(uint32_t intnum, xtos_handler handler, void* param, xtos_handler* pprev)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_xtos_set_interrupt_handler);
  cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.xtos_set_interrupt_handler_CallInstance);
  Mock.xtos_set_interrupt_handler_CallInstance = CMock_Guts_MemNext(Mock.xtos_set_interrupt_handler_CallInstance);
  if (Mock.xtos_set_interrupt_handler_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    if (cmock_call_instance == NULL)
      return Mock.xtos_set_interrupt_handler_FinalReturn;
    Mock.xtos_set_interrupt_handler_FinalReturn = cmock_call_instance->ReturnVal;
    return cmock_call_instance->ReturnVal;
  }
  if (!Mock.xtos_set_interrupt_handler_CallbackBool &&
      Mock.xtos_set_interrupt_handler_CallbackFunctionPointer != NULL)
  {
    int32_t cmock_cb_ret = Mock.xtos_set_interrupt_handler_CallbackFunctionPointer(intnum, handler, param, pprev, Mock.xtos_set_interrupt_handler_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return cmock_cb_ret;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (!cmock_call_instance->ExpectAnyArgsBool)
  {
  if (!cmock_call_instance->IgnoreArg_intnum)
  {
    UNITY_SET_DETAILS(CMockString_xtos_set_interrupt_handler,CMockString_intnum);
    UNITY_TEST_ASSERT_EQUAL_HEX32(cmock_call_instance->Expected_intnum, intnum, cmock_line, CMockStringMismatch);
  }
  if (!cmock_call_instance->IgnoreArg_handler)
  {
    UNITY_SET_DETAILS(CMockString_xtos_set_interrupt_handler,CMockString_handler);
    UNITY_TEST_ASSERT_EQUAL_MEMORY((void*)(&cmock_call_instance->Expected_handler), (void*)(&handler), sizeof(xtos_handler), cmock_line, CMockStringMismatch);
  }
  if (!cmock_call_instance->IgnoreArg_param)
  {
    UNITY_SET_DETAILS(CMockString_xtos_set_interrupt_handler,CMockString_param);
    if (cmock_call_instance->Expected_param == NULL)
      { UNITY_TEST_ASSERT_NULL(param, cmock_line, CMockStringExpNULL); }
    else
      { UNITY_TEST_ASSERT_EQUAL_HEX8_ARRAY(cmock_call_instance->Expected_param, param, cmock_call_instance->Expected_param_Depth, cmock_line, CMockStringMismatch); }
  }
  if (!cmock_call_instance->IgnoreArg_pprev)
  {
    UNITY_SET_DETAILS(CMockString_xtos_set_interrupt_handler,CMockString_pprev);
    if (cmock_call_instance->Expected_pprev == NULL)
      { UNITY_TEST_ASSERT_NULL(pprev, cmock_line, CMockStringExpNULL); }
    else
      { UNITY_TEST_ASSERT_EQUAL_MEMORY_ARRAY((void*)(cmock_call_instance->Expected_pprev), (void*)(pprev), sizeof(xtos_handler), cmock_call_instance->Expected_pprev_Depth, cmock_line, CMockStringMismatch); }
  }
  }
  if (Mock.xtos_set_interrupt_handler_CallbackFunctionPointer != NULL)
  {
    cmock_call_instance->ReturnVal = Mock.xtos_set_interrupt_handler_CallbackFunctionPointer(intnum, handler, param, pprev, Mock.xtos_set_interrupt_handler_CallbackCalls++);
  }
  if (cmock_call_instance->ReturnThruPtr_param_Used)
  {
    UNITY_TEST_ASSERT_NOT_NULL(param, cmock_line, CMockStringPtrIsNULL);
    memcpy((void*)param, (void*)cmock_call_instance->ReturnThruPtr_param_Val,
      cmock_call_instance->ReturnThruPtr_param_Size);
  }
  if (cmock_call_instance->ReturnThruPtr_pprev_Used)
  {
    UNITY_TEST_ASSERT_NOT_NULL(pprev, cmock_line, CMockStringPtrIsNULL);
    memcpy((void*)pprev, (void*)cmock_call_instance->ReturnThruPtr_pprev_Val,
      cmock_call_instance->ReturnThruPtr_pprev_Size);
  }
  UNITY_CLR_DETAILS();
  return cmock_call_instance->ReturnVal;
}

void CMockExpectParameters_xtos_set_interrupt_handler(CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance, uint32_t intnum, xtos_handler handler, void* param, int param_Depth, xtos_handler* pprev, int pprev_Depth);
void CMockExpectParameters_xtos_set_interrupt_handler(CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance, uint32_t intnum, xtos_handler handler, void* param, int param_Depth, xtos_handler* pprev, int pprev_Depth)
{
  cmock_call_instance->Expected_intnum = intnum;
  cmock_call_instance->IgnoreArg_intnum = 0;
  memcpy((void*)(&cmock_call_instance->Expected_handler), (void*)(&handler),
         sizeof(xtos_handler[sizeof(handler) == sizeof(xtos_handler) ? 1 : -1])); /* add xtos_handler to :treat_as_array if this causes an error */
  cmock_call_instance->IgnoreArg_handler = 0;
  cmock_call_instance->Expected_param = param;
  cmock_call_instance->Expected_param_Depth = param_Depth;
  cmock_call_instance->IgnoreArg_param = 0;
  cmock_call_instance->ReturnThruPtr_param_Used = 0;
  cmock_call_instance->Expected_pprev = pprev;
  cmock_call_instance->Expected_pprev_Depth = pprev_Depth;
  cmock_call_instance->IgnoreArg_pprev = 0;
  cmock_call_instance->ReturnThruPtr_pprev_Used = 0;
}

void xtos_set_interrupt_handler_CMockIgnoreAndReturn(UNITY_LINE_TYPE cmock_line, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE));
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_interrupt_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_interrupt_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)1;
}

void xtos_set_interrupt_handler_CMockStopIgnore(void)
{
  if(Mock.xtos_set_interrupt_handler_IgnoreBool)
    Mock.xtos_set_interrupt_handler_CallInstance = CMock_Guts_MemNext(Mock.xtos_set_interrupt_handler_CallInstance);
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)0;
}

void xtos_set_interrupt_handler_CMockExpectAnyArgsAndReturn(UNITY_LINE_TYPE cmock_line, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE));
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_interrupt_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_interrupt_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ReturnVal = cmock_to_return;
  cmock_call_instance->ExpectAnyArgsBool = (char)1;
}

void xtos_set_interrupt_handler_CMockExpectAndReturn(UNITY_LINE_TYPE cmock_line, uint32_t intnum, xtos_handler handler, void* param, xtos_handler* pprev, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE));
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_interrupt_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_interrupt_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_xtos_set_interrupt_handler(cmock_call_instance, intnum, handler, param, 1, pprev, 1);
  cmock_call_instance->ReturnVal = cmock_to_return;
}

void xtos_set_interrupt_handler_AddCallback(CMOCK_xtos_set_interrupt_handler_CALLBACK Callback)
{
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)0;
  Mock.xtos_set_interrupt_handler_CallbackBool = (char)1;
  Mock.xtos_set_interrupt_handler_CallbackFunctionPointer = Callback;
}

void xtos_set_interrupt_handler_Stub(CMOCK_xtos_set_interrupt_handler_CALLBACK Callback)
{
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)0;
  Mock.xtos_set_interrupt_handler_CallbackBool = (char)0;
  Mock.xtos_set_interrupt_handler_CallbackFunctionPointer = Callback;
}

void xtos_set_interrupt_handler_CMockExpectWithArrayAndReturn(UNITY_LINE_TYPE cmock_line, uint32_t intnum, xtos_handler handler, void* param, int param_Depth, xtos_handler* pprev, int pprev_Depth, int32_t cmock_to_return)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE));
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_set_interrupt_handler_CallInstance = CMock_Guts_MemChain(Mock.xtos_set_interrupt_handler_CallInstance, cmock_guts_index);
  Mock.xtos_set_interrupt_handler_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_xtos_set_interrupt_handler(cmock_call_instance, intnum, handler, param, param_Depth, pprev, pprev_Depth);
  cmock_call_instance->ReturnVal = cmock_to_return;
}

void xtos_set_interrupt_handler_CMockReturnMemThruPtr_param(UNITY_LINE_TYPE cmock_line, void* param, size_t cmock_size)
{
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_interrupt_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringPtrPreExp);
  cmock_call_instance->ReturnThruPtr_param_Used = 1;
  cmock_call_instance->ReturnThruPtr_param_Val = param;
  cmock_call_instance->ReturnThruPtr_param_Size = cmock_size;
}

void xtos_set_interrupt_handler_CMockReturnMemThruPtr_pprev(UNITY_LINE_TYPE cmock_line, xtos_handler* pprev, size_t cmock_size)
{
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_interrupt_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringPtrPreExp);
  cmock_call_instance->ReturnThruPtr_pprev_Used = 1;
  cmock_call_instance->ReturnThruPtr_pprev_Val = pprev;
  cmock_call_instance->ReturnThruPtr_pprev_Size = cmock_size;
}

void xtos_set_interrupt_handler_CMockIgnoreArg_intnum(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_interrupt_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_intnum = 1;
}

void xtos_set_interrupt_handler_CMockIgnoreArg_handler(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_interrupt_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_handler = 1;
}

void xtos_set_interrupt_handler_CMockIgnoreArg_param(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_interrupt_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_param = 1;
}

void xtos_set_interrupt_handler_CMockIgnoreArg_pprev(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_set_interrupt_handler_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_set_interrupt_handler_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_pprev = 1;
}

void xtos_interrupt_enable(uint32_t cmock_arg1)
{
  UNITY_LINE_TYPE cmock_line = TEST_LINE_NUM;
  CMOCK_xtos_interrupt_enable_CALL_INSTANCE* cmock_call_instance;
  UNITY_SET_DETAIL(CMockString_xtos_interrupt_enable);
  cmock_call_instance = (CMOCK_xtos_interrupt_enable_CALL_INSTANCE*)CMock_Guts_GetAddressFor(Mock.xtos_interrupt_enable_CallInstance);
  Mock.xtos_interrupt_enable_CallInstance = CMock_Guts_MemNext(Mock.xtos_interrupt_enable_CallInstance);
  if (Mock.xtos_interrupt_enable_IgnoreBool)
  {
    UNITY_CLR_DETAILS();
    return;
  }
  if (!Mock.xtos_interrupt_enable_CallbackBool &&
      Mock.xtos_interrupt_enable_CallbackFunctionPointer != NULL)
  {
    Mock.xtos_interrupt_enable_CallbackFunctionPointer(cmock_arg1, Mock.xtos_interrupt_enable_CallbackCalls++);
    UNITY_CLR_DETAILS();
    return;
  }
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringCalledMore);
  cmock_line = cmock_call_instance->LineNumber;
  if (!cmock_call_instance->ExpectAnyArgsBool)
  {
  if (!cmock_call_instance->IgnoreArg_cmock_arg1)
  {
    UNITY_SET_DETAILS(CMockString_xtos_interrupt_enable,CMockString_cmock_arg1);
    UNITY_TEST_ASSERT_EQUAL_HEX32(cmock_call_instance->Expected_cmock_arg1, cmock_arg1, cmock_line, CMockStringMismatch);
  }
  }
  if (Mock.xtos_interrupt_enable_CallbackFunctionPointer != NULL)
  {
    Mock.xtos_interrupt_enable_CallbackFunctionPointer(cmock_arg1, Mock.xtos_interrupt_enable_CallbackCalls++);
  }
  UNITY_CLR_DETAILS();
}

void CMockExpectParameters_xtos_interrupt_enable(CMOCK_xtos_interrupt_enable_CALL_INSTANCE* cmock_call_instance, uint32_t cmock_arg1);
void CMockExpectParameters_xtos_interrupt_enable(CMOCK_xtos_interrupt_enable_CALL_INSTANCE* cmock_call_instance, uint32_t cmock_arg1)
{
  cmock_call_instance->Expected_cmock_arg1 = cmock_arg1;
  cmock_call_instance->IgnoreArg_cmock_arg1 = 0;
}

void xtos_interrupt_enable_CMockIgnore(void)
{
  Mock.xtos_interrupt_enable_IgnoreBool = (char)1;
}

void xtos_interrupt_enable_CMockStopIgnore(void)
{
  Mock.xtos_interrupt_enable_IgnoreBool = (char)0;
}

void xtos_interrupt_enable_CMockExpectAnyArgs(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_interrupt_enable_CALL_INSTANCE));
  CMOCK_xtos_interrupt_enable_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_interrupt_enable_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_interrupt_enable_CallInstance = CMock_Guts_MemChain(Mock.xtos_interrupt_enable_CallInstance, cmock_guts_index);
  Mock.xtos_interrupt_enable_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  cmock_call_instance->ExpectAnyArgsBool = (char)1;
}

void xtos_interrupt_enable_CMockExpect(UNITY_LINE_TYPE cmock_line, uint32_t cmock_arg1)
{
  CMOCK_MEM_INDEX_TYPE cmock_guts_index = CMock_Guts_MemNew(sizeof(CMOCK_xtos_interrupt_enable_CALL_INSTANCE));
  CMOCK_xtos_interrupt_enable_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_interrupt_enable_CALL_INSTANCE*)CMock_Guts_GetAddressFor(cmock_guts_index);
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringOutOfMemory);
  memset(cmock_call_instance, 0, sizeof(*cmock_call_instance));
  Mock.xtos_interrupt_enable_CallInstance = CMock_Guts_MemChain(Mock.xtos_interrupt_enable_CallInstance, cmock_guts_index);
  Mock.xtos_interrupt_enable_IgnoreBool = (char)0;
  cmock_call_instance->LineNumber = cmock_line;
  cmock_call_instance->ExpectAnyArgsBool = (char)0;
  CMockExpectParameters_xtos_interrupt_enable(cmock_call_instance, cmock_arg1);
}

void xtos_interrupt_enable_AddCallback(CMOCK_xtos_interrupt_enable_CALLBACK Callback)
{
  Mock.xtos_interrupt_enable_IgnoreBool = (char)0;
  Mock.xtos_interrupt_enable_CallbackBool = (char)1;
  Mock.xtos_interrupt_enable_CallbackFunctionPointer = Callback;
}

void xtos_interrupt_enable_Stub(CMOCK_xtos_interrupt_enable_CALLBACK Callback)
{
  Mock.xtos_interrupt_enable_IgnoreBool = (char)0;
  Mock.xtos_interrupt_enable_CallbackBool = (char)0;
  Mock.xtos_interrupt_enable_CallbackFunctionPointer = Callback;
}

void xtos_interrupt_enable_CMockIgnoreArg_cmock_arg1(UNITY_LINE_TYPE cmock_line)
{
  CMOCK_xtos_interrupt_enable_CALL_INSTANCE* cmock_call_instance = (CMOCK_xtos_interrupt_enable_CALL_INSTANCE*)CMock_Guts_GetAddressFor(CMock_Guts_MemEndOfChain(Mock.xtos_interrupt_enable_CallInstance));
  UNITY_TEST_ASSERT_NOT_NULL(cmock_call_instance, cmock_line, CMockStringIgnPreExp);
  cmock_call_instance->IgnoreArg_cmock_arg1 = 1;
}

